# AI Precompiles

Axonum has additional precompiles that are not present on Ethereum. These precompiles are designed to provide additional functionality to developers building on Axonum. The following precompiles are available on Axonum:

## Inference Precompile

Address: `0xa1`

The inference precompile is used to run machine learning models on Axonum.

* Input:
  * `model_address` (bytes32): See [Available models](#available-models)
  * `input_data` (bytes): The input data for the model
  * `output_size` (uint256): The size of the output data in bytes
* Output:
  * The output data from the model (bytes)

### Available models

| Model Address                                                        | Model Name                              | Prompt Template                                  |
| -------------------------------------------------------------------- | --------------------------------------- | ------------------------------------------------ |
| `0x0000000000000000000000000000000000000000000000000000000000000001` | `microsoft/Phi-3-mini-4k-instruct-gguf` | `<\|user\|>\n{PROMPT}<\|end\|>\n<\|assistant\|>` |

To use the inference precompile, check out how to [deploy on AI EVM](/builders/deploy-on-ai-evm.md).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.axonum.io/chain/precompiles.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
